Index: LMDZ6/branches/Amaury_dev/libf/phylmd/cv_routines.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/cv_routines.F90	(revision 5140)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/cv_routines.F90	(revision 5141)
@@ -1,3 +1,2 @@
-
 ! $Id$
 
@@ -38,6 +37,6 @@
   include "cvparam.h"
   INTEGER nd
-  CHARACTER (LEN=20) :: modname = 'cv_routines'
-  CHARACTER (LEN=80) :: abort_message
+  CHARACTER (LEN = 20) :: modname = 'cv_routines'
+  CHARACTER (LEN = 80) :: abort_message
 
   ! noff: integer limit for convection (nd-noff)
@@ -71,8 +70,9 @@
   delta = 0.01 ! cld
 
-
 END SUBROUTINE cv_param
 
 SUBROUTINE cv_prelim(len, nd, ndp1, t, q, p, ph, lv, cpn, tv, gz, h, hm)
+  USE lmdz_cvthermo
+
   IMPLICIT NONE
 
@@ -93,14 +93,12 @@
   REAL cpx(len, nd)
 
-  include "cvthermo.h"
   include "cvparam.h"
-
 
   DO k = 1, nlp
     DO i = 1, len
-      lv(i, k) = lv0 - clmcpv*(t(i,k)-t0)
-      cpn(i, k) = cpd*(1.0-q(i,k)) + cpv*q(i, k)
-      cpx(i, k) = cpd*(1.0-q(i,k)) + cl*q(i, k)
-      tv(i, k) = t(i, k)*(1.0+q(i,k)*epsim1)
+      lv(i, k) = lv0 - clmcpv * (t(i, k) - t0)
+      cpn(i, k) = cpd * (1.0 - q(i, k)) + cpv * q(i, k)
+      cpx(i, k) = cpd * (1.0 - q(i, k)) + cl * q(i, k)
+      tv(i, k) = t(i, k) * (1.0 + q(i, k) * epsim1)
     END DO
   END DO
@@ -113,6 +111,6 @@
   DO k = 2, nlp
     DO i = 1, len
-      gz(i, k) = gz(i, k-1) + hrd*(tv(i,k-1)+tv(i,k))*(p(i,k-1)-p(i,k))/ph(i, &
-        k)
+      gz(i, k) = gz(i, k - 1) + hrd * (tv(i, k - 1) + tv(i, k)) * (p(i, k - 1) - p(i, k)) / ph(i, &
+              k)
     END DO
   END DO
@@ -123,14 +121,13 @@
   DO k = 1, nlp
     DO i = 1, len
-      h(i, k) = gz(i, k) + cpn(i, k)*t(i, k)
-      hm(i, k) = gz(i, k) + cpx(i, k)*(t(i,k)-t(i,1)) + lv(i, k)*q(i, k)
-    END DO
-  END DO
-
+      h(i, k) = gz(i, k) + cpn(i, k) * t(i, k)
+      hm(i, k) = gz(i, k) + cpx(i, k) * (t(i, k) - t(i, 1)) + lv(i, k) * q(i, k)
+    END DO
+  END DO
 
 END SUBROUTINE cv_prelim
 
 SUBROUTINE cv_feed(len, nd, t, q, qs, p, hm, gz, nk, icb, icbmax, iflag, tnk, &
-    qnk, gznk, plcl)
+        qnk, gznk, plcl)
   IMPLICIT NONE
 
@@ -169,5 +166,5 @@
   DO k = 2, nlp
     DO i = 1, len
-      IF ((hm(i,k)<work(i)) .AND. (hm(i,k)<hm(i,k-1))) THEN
+      IF ((hm(i, k)<work(i)) .AND. (hm(i, k)<hm(i, k - 1))) THEN
         work(i) = hm(i, k)
         ihmin(i) = k
@@ -193,5 +190,5 @@
   DO k = minorig + 1, nl
     DO i = 1, len
-      IF ((hm(i,k)>work(i)) .AND. (k<=ihmin(i))) THEN
+      IF ((hm(i, k)>work(i)) .AND. (k<=ihmin(i))) THEN
         work(i) = hm(i, k)
         nk(i) = k
@@ -204,6 +201,6 @@
   ! -------------------------------------------------------------------
   DO i = 1, len
-    IF (((t(i,nk(i))<250.0) .OR. (q(i,nk(i))<=0.0) .OR. (p(i,ihmin(i))< &
-      400.0)) .AND. (iflag(i)==0)) iflag(i) = 7
+    IF (((t(i, nk(i))<250.0) .OR. (q(i, nk(i))<=0.0) .OR. (p(i, ihmin(i))< &
+            400.0)) .AND. (iflag(i)==0)) iflag(i) = 7
   END DO
   ! -------------------------------------------------------------------
@@ -218,10 +215,10 @@
     qsnk(i) = qs(i, nk(i))
 
-    rh(i) = qnk(i)/qsnk(i)
+    rh(i) = qnk(i) / qsnk(i)
     rh(i) = min(1.0, rh(i))
-    chi(i) = tnk(i)/(1669.0-122.0*rh(i)-tnk(i))
-    plcl(i) = pnk(i)*(rh(i)**chi(i))
+    chi(i) = tnk(i) / (1669.0 - 122.0 * rh(i) - tnk(i))
+    plcl(i) = pnk(i) * (rh(i)**chi(i))
     IF (((plcl(i)<200.0) .OR. (plcl(i)>=2000.0)) .AND. (iflag(i)==0)) iflag(i &
-      ) = 8
+            ) = 8
   END DO
   ! -------------------------------------------------------------------
@@ -234,5 +231,5 @@
   DO k = minorig, nl
     DO i = 1, len
-      IF ((k>=(nk(i)+1)) .AND. (p(i,k)<plcl(i))) icb(i) = min(icb(i), k)
+      IF ((k>=(nk(i) + 1)) .AND. (p(i, k)<plcl(i))) icb(i) = min(icb(i), k)
     END DO
   END DO
@@ -249,12 +246,12 @@
   END DO
 
-
 END SUBROUTINE cv_feed
 
 SUBROUTINE cv_undilute1(len, nd, t, q, qs, gz, p, nk, icb, icbmax, tp, tvp, &
-    clw)
+        clw)
+  USE lmdz_cvthermo
+
   IMPLICIT NONE
 
-  include "cvthermo.h"
   include "cvparam.h"
 
@@ -292,7 +289,7 @@
 
   DO i = 1, len
-    ah0(i) = (cpd*(1.-qnk(i))+cl*qnk(i))*tnk(i) + qnk(i)*(lv0-clmcpv*(tnk(i)- &
-      273.15)) + gznk(i)
-    cpp(i) = cpd*(1.-qnk(i)) + qnk(i)*cpv
+    ah0(i) = (cpd * (1. - qnk(i)) + cl * qnk(i)) * tnk(i) + qnk(i) * (lv0 - clmcpv * (tnk(i) - &
+            273.15)) + gznk(i)
+    cpp(i) = cpd * (1. - qnk(i)) + qnk(i) * cpv
   END DO
 
@@ -301,6 +298,6 @@
   DO k = minorig, icbmax - 1
     DO i = 1, len
-      tp(i, k) = tnk(i) - (gz(i,k)-gznk(i))/cpp(i)
-      tvp(i, k) = tp(i, k)*(1.+qnk(i)*epsi)
+      tp(i, k) = tnk(i) - (gz(i, k) - gznk(i)) / cpp(i)
+      tvp(i, k) = tp(i, k) * (1. + qnk(i) * epsi)
     END DO
   END DO
@@ -311,52 +308,51 @@
     tg = ticb(i)
     qg = qs(i, icb(i))
-    alv = lv0 - clmcpv*(ticb(i)-t0)
+    alv = lv0 - clmcpv * (ticb(i) - t0)
 
     ! First iteration.
 
-    s = cpd + alv*alv*qg/(rrv*ticb(i)*ticb(i))
-    s = 1./s
-    ahg = cpd*tg + (cl-cpd)*qnk(i)*ticb(i) + alv*qg + gzicb(i)
-    tg = tg + s*(ah0(i)-ahg)
+    s = cpd + alv * alv * qg / (rrv * ticb(i) * ticb(i))
+    s = 1. / s
+    ahg = cpd * tg + (cl - cpd) * qnk(i) * ticb(i) + alv * qg + gzicb(i)
+    tg = tg + s * (ah0(i) - ahg)
     tg = max(tg, 35.0)
     tc = tg - t0
     denom = 243.5 + tc
     IF (tc>=0.0) THEN
-      es = 6.112*exp(17.67*tc/denom)
+      es = 6.112 * exp(17.67 * tc / denom)
     ELSE
-      es = exp(23.33086-6111.72784/tg+0.15215*log(tg))
+      es = exp(23.33086 - 6111.72784 / tg + 0.15215 * log(tg))
     END IF
-    qg = eps*es/(p(i,icb(i))-es*(1.-eps))
+    qg = eps * es / (p(i, icb(i)) - es * (1. - eps))
 
     ! Second iteration.
 
-    s = cpd + alv*alv*qg/(rrv*ticb(i)*ticb(i))
-    s = 1./s
-    ahg = cpd*tg + (cl-cpd)*qnk(i)*ticb(i) + alv*qg + gzicb(i)
-    tg = tg + s*(ah0(i)-ahg)
+    s = cpd + alv * alv * qg / (rrv * ticb(i) * ticb(i))
+    s = 1. / s
+    ahg = cpd * tg + (cl - cpd) * qnk(i) * ticb(i) + alv * qg + gzicb(i)
+    tg = tg + s * (ah0(i) - ahg)
     tg = max(tg, 35.0)
     tc = tg - t0
     denom = 243.5 + tc
     IF (tc>=0.0) THEN
-      es = 6.112*exp(17.67*tc/denom)
+      es = 6.112 * exp(17.67 * tc / denom)
     ELSE
-      es = exp(23.33086-6111.72784/tg+0.15215*log(tg))
+      es = exp(23.33086 - 6111.72784 / tg + 0.15215 * log(tg))
     END IF
-    qg = eps*es/(p(i,icb(i))-es*(1.-eps))
-
-    alv = lv0 - clmcpv*(ticb(i)-273.15)
-    tp(i, icb(i)) = (ah0(i)-(cl-cpd)*qnk(i)*ticb(i)-gz(i,icb(i))-alv*qg)/cpd
+    qg = eps * es / (p(i, icb(i)) - es * (1. - eps))
+
+    alv = lv0 - clmcpv * (ticb(i) - 273.15)
+    tp(i, icb(i)) = (ah0(i) - (cl - cpd) * qnk(i) * ticb(i) - gz(i, icb(i)) - alv * qg) / cpd
     clw(i, icb(i)) = qnk(i) - qg
-    clw(i, icb(i)) = max(0.0, clw(i,icb(i)))
-    rg = qg/(1.-qnk(i))
-    tvp(i, icb(i)) = tp(i, icb(i))*(1.+rg*epsi)
+    clw(i, icb(i)) = max(0.0, clw(i, icb(i)))
+    rg = qg / (1. - qnk(i))
+    tvp(i, icb(i)) = tp(i, icb(i)) * (1. + rg * epsi)
   END DO
 
   DO k = minorig, icbmax
     DO i = 1, len
-      tvp(i, k) = tvp(i, k) - tp(i, k)*qnk(i)
-    END DO
-  END DO
-
+      tvp(i, k) = tvp(i, k) - tp(i, k) * qnk(i)
+    END DO
+  END DO
 
 END SUBROUTINE cv_undilute1
@@ -383,17 +379,15 @@
   INTEGER i
 
-
   DO i = 1, len
     IF ((cbmf(i)==0.0) .AND. (iflag(i)==0) .AND. (tvp(i, &
-      icb(i))<=(tv(i,icb(i))-dtmax))) iflag(i) = 4
-  END DO
-
+            icb(i))<=(tv(i, icb(i)) - dtmax))) iflag(i) = 4
+  END DO
 
 END SUBROUTINE cv_trigger
 
 SUBROUTINE cv_compress(len, nloc, ncum, nd, iflag1, nk1, icb1, cbmf1, plcl1, &
-    tnk1, qnk1, gznk1, t1, q1, qs1, u1, v1, gz1, h1, lv1, cpn1, p1, ph1, tv1, &
-    tp1, tvp1, clw1, iflag, nk, icb, cbmf, plcl, tnk, qnk, gznk, t, q, qs, u, &
-    v, gz, h, lv, cpn, p, ph, tv, tp, tvp, clw, dph)
+        tnk1, qnk1, gznk1, t1, q1, qs1, u1, v1, gz1, h1, lv1, cpn1, p1, ph1, tv1, &
+        tp1, tvp1, clw1, iflag, nk, icb, cbmf, plcl, tnk, qnk, gznk, t, q, qs, u, &
+        v, gz, h, lv, cpn, p, ph, tv, tp, tvp, clw, dph)
   USE lmdz_print_control, ONLY: lunout
   USE lmdz_abort_physic, ONLY: abort_physic
@@ -408,5 +402,5 @@
   REAL t1(len, nd), q1(len, nd), qs1(len, nd), u1(len, nd), v1(len, nd)
   REAL gz1(len, nd), h1(len, nd), lv1(len, nd), cpn1(len, nd)
-  REAL p1(len, nd), ph1(len, nd+1), tv1(len, nd), tp1(len, nd)
+  REAL p1(len, nd), ph1(len, nd + 1), tv1(len, nd), tp1(len, nd)
   REAL tvp1(len, nd), clw1(len, nd)
 
@@ -416,5 +410,5 @@
   REAL t(nloc, nd), q(nloc, nd), qs(nloc, nd), u(nloc, nd), v(nloc, nd)
   REAL gz(nloc, nd), h(nloc, nd), lv(nloc, nd), cpn(nloc, nd)
-  REAL p(nloc, nd), ph(nloc, nd+1), tv(nloc, nd), tp(nloc, nd)
+  REAL p(nloc, nd), ph(nloc, nd + 1), tv(nloc, nd), tp(nloc, nd)
   REAL tvp(nloc, nd), clw(nloc, nd)
   REAL dph(nloc, nd)
@@ -422,7 +416,6 @@
   ! local variables:
   INTEGER i, k, nn
-  CHARACTER (LEN=20) :: modname = 'cv_compress'
-  CHARACTER (LEN=80) :: abort_message
-
+  CHARACTER (LEN = 20) :: modname = 'cv_compress'
+  CHARACTER (LEN = 80) :: abort_message
 
   DO k = 1, nl + 1
@@ -473,13 +466,14 @@
   DO k = 1, nl
     DO i = 1, ncum
-      dph(i, k) = ph(i, k) - ph(i, k+1)
-    END DO
-  END DO
-
+      dph(i, k) = ph(i, k) - ph(i, k + 1)
+    END DO
+  END DO
 
 END SUBROUTINE cv_compress
 
 SUBROUTINE cv_undilute2(nloc, ncum, nd, icb, nk, tnk, qnk, gznk, t, q, qs, &
-    gz, p, dph, h, tv, lv, inb, inb1, tp, tvp, clw, hp, ep, sigp, frac)
+        gz, p, dph, h, tv, lv, inb, inb1, tp, tvp, clw, hp, ep, sigp, frac)
+  USE lmdz_cvthermo
+
   IMPLICIT NONE
 
@@ -494,5 +488,4 @@
   ! ---------------------------------------------------------------------
 
-  include "cvthermo.h"
   include "cvparam.h"
 
@@ -538,8 +531,7 @@
   ! ***  Calculate certain parcel quantities, including static energy   ***
 
-
-  DO i = 1, ncum
-    ah0(i) = (cpd*(1.-qnk(i))+cl*qnk(i))*tnk(i) + qnk(i)*(lv0-clmcpv*(tnk(i)- &
-      t0)) + gznk(i)
+  DO i = 1, ncum
+    ah0(i) = (cpd * (1. - qnk(i)) + cl * qnk(i)) * tnk(i) + qnk(i) * (lv0 - clmcpv * (tnk(i) - &
+            t0)) + gznk(i)
   END DO
 
@@ -547,49 +539,48 @@
   ! ***  Find lifted parcel quantities above cloud base    ***
 
-
   DO k = minorig + 1, nl
     DO i = 1, ncum
-      IF (k>=(icb(i)+1)) THEN
+      IF (k>=(icb(i) + 1)) THEN
         tg = t(i, k)
         qg = qs(i, k)
-        alv = lv0 - clmcpv*(t(i,k)-t0)
+        alv = lv0 - clmcpv * (t(i, k) - t0)
 
         ! First iteration.
 
-        s = cpd + alv*alv*qg/(rrv*t(i,k)*t(i,k))
-        s = 1./s
-        ahg = cpd*tg + (cl-cpd)*qnk(i)*t(i, k) + alv*qg + gz(i, k)
-        tg = tg + s*(ah0(i)-ahg)
+        s = cpd + alv * alv * qg / (rrv * t(i, k) * t(i, k))
+        s = 1. / s
+        ahg = cpd * tg + (cl - cpd) * qnk(i) * t(i, k) + alv * qg + gz(i, k)
+        tg = tg + s * (ah0(i) - ahg)
         tg = max(tg, 35.0)
         tc = tg - t0
         denom = 243.5 + tc
         IF (tc>=0.0) THEN
-          es = 6.112*exp(17.67*tc/denom)
+          es = 6.112 * exp(17.67 * tc / denom)
         ELSE
-          es = exp(23.33086-6111.72784/tg+0.15215*log(tg))
+          es = exp(23.33086 - 6111.72784 / tg + 0.15215 * log(tg))
         END IF
-        qg = eps*es/(p(i,k)-es*(1.-eps))
+        qg = eps * es / (p(i, k) - es * (1. - eps))
 
         ! Second iteration.
 
-        s = cpd + alv*alv*qg/(rrv*t(i,k)*t(i,k))
-        s = 1./s
-        ahg = cpd*tg + (cl-cpd)*qnk(i)*t(i, k) + alv*qg + gz(i, k)
-        tg = tg + s*(ah0(i)-ahg)
+        s = cpd + alv * alv * qg / (rrv * t(i, k) * t(i, k))
+        s = 1. / s
+        ahg = cpd * tg + (cl - cpd) * qnk(i) * t(i, k) + alv * qg + gz(i, k)
+        tg = tg + s * (ah0(i) - ahg)
         tg = max(tg, 35.0)
         tc = tg - t0
         denom = 243.5 + tc
         IF (tc>=0.0) THEN
-          es = 6.112*exp(17.67*tc/denom)
+          es = 6.112 * exp(17.67 * tc / denom)
         ELSE
-          es = exp(23.33086-6111.72784/tg+0.15215*log(tg))
+          es = exp(23.33086 - 6111.72784 / tg + 0.15215 * log(tg))
         END IF
-        qg = eps*es/(p(i,k)-es*(1.-eps))
-
-        alv = lv0 - clmcpv*(t(i,k)-t0)
+        qg = eps * es / (p(i, k) - es * (1. - eps))
+
+        alv = lv0 - clmcpv * (t(i, k) - t0)
         ! PRINT*,'cpd dans convect2 ',cpd
         ! PRINT*,'tp(i,k),ah0(i),cl,cpd,qnk(i),t(i,k),gz(i,k),alv,qg,cpd'
         ! PRINT*,tp(i,k),ah0(i),cl,cpd,qnk(i),t(i,k),gz(i,k),alv,qg,cpd
-        tp(i, k) = (ah0(i)-(cl-cpd)*qnk(i)*t(i,k)-gz(i,k)-alv*qg)/cpd
+        tp(i, k) = (ah0(i) - (cl - cpd) * qnk(i) * t(i, k) - gz(i, k) - alv * qg) / cpd
         ! if (.NOT.cpd.gt.1000.) THEN
         ! PRINT*,'CPD=',cpd
@@ -597,7 +588,7 @@
         ! END IF
         clw(i, k) = qnk(i) - qg
-        clw(i, k) = max(0.0, clw(i,k))
-        rg = qg/(1.-qnk(i))
-        tvp(i, k) = tp(i, k)*(1.+rg*epsi)
+        clw(i, k) = max(0.0, clw(i, k))
+        rg = qg / (1. - qnk(i))
+        tvp(i, k) = tp(i, k) * (1. + rg * epsi)
       END IF
     END DO
@@ -612,15 +603,15 @@
   DO k = minorig + 1, nl
     DO i = 1, ncum
-      IF (k>=(nk(i)+1)) THEN
+      IF (k>=(nk(i) + 1)) THEN
         tca = tp(i, k) - t0
         IF (tca>=0.0) THEN
           elacrit = elcrit
         ELSE
-          elacrit = elcrit*(1.0-tca/tlcrit)
+          elacrit = elcrit * (1.0 - tca / tlcrit)
         END IF
         elacrit = max(elacrit, 0.0)
-        ep(i, k) = 1.0 - elacrit/max(clw(i,k), 1.0E-8)
-        ep(i, k) = max(ep(i,k), 0.0)
-        ep(i, k) = min(ep(i,k), 1.0)
+        ep(i, k) = 1.0 - elacrit / max(clw(i, k), 1.0E-8)
+        ep(i, k) = max(ep(i, k), 0.0)
+        ep(i, k) = min(ep(i, k), 1.0)
         sigp(i, k) = sigs
       END IF
@@ -635,6 +626,6 @@
   DO k = minorig + 1, nl
     DO i = 1, ncum
-      IF (k>=(icb(i)+1)) THEN
-        tvp(i, k) = tvp(i, k)*(1.0-qnk(i)+ep(i,k)*clw(i,k))
+      IF (k>=(icb(i) + 1)) THEN
+        tvp(i, k) = tvp(i, k) * (1.0 - qnk(i) + ep(i, k) * clw(i, k))
         ! PRINT*,'i,k,tvp(i,k),qnk(i),ep(i,k),clw(i,k)'
         ! PRINT*, i,k,tvp(i,k),qnk(i),ep(i,k),clw(i,k)
@@ -643,5 +634,5 @@
   END DO
   DO i = 1, ncum
-    tvp(i, nlp) = tvp(i, nl) - (gz(i,nlp)-gz(i,nl))/cpd
+    tvp(i, nlp) = tvp(i, nl) - (gz(i, nlp) - gz(i, nl)) / cpd
   END DO
 
@@ -721,7 +712,7 @@
     DO i = 1, ncum
       IF (cape(i)<0.0) lcape(i) = .FALSE.
-      IF ((k>=(icb(i)+1)) .AND. lcape(i)) THEN
-        by = (tvp(i,k)-tv(i,k))*dph(i, k)/p(i, k)
-        byp(i) = (tvp(i,k+1)-tv(i,k+1))*dph(i, k+1)/p(i, k+1)
+      IF ((k>=(icb(i) + 1)) .AND. lcape(i)) THEN
+        by = (tvp(i, k) - tv(i, k)) * dph(i, k) / p(i, k)
+        byp(i) = (tvp(i, k + 1) - tv(i, k + 1)) * dph(i, k + 1) / p(i, k + 1)
         cape(i) = cape(i) + by
         IF (by>=0.0) inb1(i) = k + 1
@@ -737,5 +728,5 @@
     defrac = capem(i) - cape(i)
     defrac = max(defrac, 0.001)
-    frac(i) = -cape(i)/defrac
+    frac(i) = -cape(i) / defrac
     frac(i) = min(frac(i), 1.0)
     frac(i) = max(frac(i), 0.0)
@@ -747,5 +738,5 @@
 
   ! initialization:
-  DO i = 1, ncum*nlp
+  DO i = 1, ncum * nlp
     hp(i, 1) = h(i, 1)
   END DO
@@ -754,15 +745,16 @@
     DO i = 1, ncum
       IF ((k>=icb(i)) .AND. (k<=inb(i))) THEN
-        hp(i, k) = h(i, nk(i)) + (lv(i,k)+(cpd-cpv)*t(i,k))*ep(i, k)*clw(i, k &
-          )
-      END IF
-    END DO
-  END DO
-
+        hp(i, k) = h(i, nk(i)) + (lv(i, k) + (cpd - cpv) * t(i, k)) * ep(i, k) * clw(i, k &
+                )
+      END IF
+    END DO
+  END DO
 
 END SUBROUTINE cv_undilute2
 
 SUBROUTINE cv_closure(nloc, ncum, nd, nk, icb, tv, tvp, p, ph, dph, plcl, &
-    cpn, iflag, cbmf)
+        cpn, iflag, cbmf)
+  USE lmdz_cvthermo
+
   IMPLICIT NONE
 
@@ -771,5 +763,5 @@
   INTEGER nk(nloc), icb(nloc)
   REAL tv(nloc, nd), tvp(nloc, nd), p(nloc, nd), dph(nloc, nd)
-  REAL ph(nloc, nd+1) ! caution nd instead ndp1 to be consistent...
+  REAL ph(nloc, nd + 1) ! caution nd instead ndp1 to be consistent...
   REAL plcl(nloc), cpn(nloc, nd)
 
@@ -783,5 +775,4 @@
   REAL work(nloc)
 
-  include "cvthermo.h"
   include "cvparam.h"
 
@@ -805,8 +796,8 @@
   DO i = 1, ncum
     dtpbl(i) = 0.0
-    tvpplcl(i) = tvp(i, icb(i)-1) - rrd*tvp(i, icb(i)-1)*(p(i,icb(i)-1)-plcl( &
-      i))/(cpn(i,icb(i)-1)*p(i,icb(i)-1))
-    tvaplcl(i) = tv(i, icb(i)) + (tvp(i,icb(i))-tvp(i,icb(i)+1))*(plcl(i)-p(i &
-      ,icb(i)))/(p(i,icb(i))-p(i,icb(i)+1))
+    tvpplcl(i) = tvp(i, icb(i) - 1) - rrd * tvp(i, icb(i) - 1) * (p(i, icb(i) - 1) - plcl(&
+            i)) / (cpn(i, icb(i) - 1) * p(i, icb(i) - 1))
+    tvaplcl(i) = tv(i, icb(i)) + (tvp(i, icb(i)) - tvp(i, icb(i) + 1)) * (plcl(i) - p(i &
+            , icb(i))) / (p(i, icb(i)) - p(i, icb(i) + 1))
   END DO
 
@@ -820,11 +811,11 @@
   DO k = minorig, icbmax
     DO i = 1, ncum
-      IF ((k>=nk(i)) .AND. (k<=(icb(i)-1))) THEN
-        dtpbl(i) = dtpbl(i) + (tvp(i,k)-tv(i,k))*dph(i, k)
-      END IF
-    END DO
-  END DO
-  DO i = 1, ncum
-    dtpbl(i) = dtpbl(i)/(ph(i,nk(i))-ph(i,icb(i)))
+      IF ((k>=nk(i)) .AND. (k<=(icb(i) - 1))) THEN
+        dtpbl(i) = dtpbl(i) + (tvp(i, k) - tv(i, k)) * dph(i, k)
+      END IF
+    END DO
+  END DO
+  DO i = 1, ncum
+    dtpbl(i) = dtpbl(i) / (ph(i, nk(i)) - ph(i, icb(i)))
     dtmin(i) = tvpplcl(i) - tvaplcl(i) + dtmax + dtpbl(i)
   END DO
@@ -836,5 +827,5 @@
   DO i = 1, ncum
     work(i) = cbmf(i)
-    cbmf(i) = max(0.0, (1.0-damp)*cbmf(i)+0.1*alpha*dtmin(i))
+    cbmf(i) = max(0.0, (1.0 - damp) * cbmf(i) + 0.1 * alpha * dtmin(i))
     IF ((work(i)==0.0) .AND. (cbmf(i)==0.0)) THEN
       iflag(i) = 3
@@ -842,13 +833,13 @@
   END DO
 
-
 END SUBROUTINE cv_closure
 
 SUBROUTINE cv_mixing(nloc, ncum, nd, icb, nk, inb, inb1, ph, t, q, qs, u, v, &
-    h, lv, qnk, hp, tv, tvp, ep, clw, cbmf, m, ment, qent, uent, vent, nent, &
-    sij, elij)
+        h, lv, qnk, hp, tv, tvp, ep, clw, cbmf, m, ment, qent, uent, vent, nent, &
+        sij, elij)
+  USE lmdz_cvthermo
+
   IMPLICIT NONE
 
-  include "cvthermo.h"
   include "cvparam.h"
 
@@ -857,5 +848,5 @@
   INTEGER icb(nloc), inb(nloc), inb1(nloc), nk(nloc)
   REAL cbmf(nloc), qnk(nloc)
-  REAL ph(nloc, nd+1)
+  REAL ph(nloc, nd + 1)
   REAL t(nloc, nd), q(nloc, nd), qs(nloc, nd), lv(nloc, nd)
   REAL u(nloc, nd), v(nloc, nd), h(nloc, nd), hp(nloc, nd)
@@ -881,5 +872,5 @@
   ! =====================================================================
 
-  DO i = 1, ncum*nlp
+  DO i = 1, ncum * nlp
     nent(i, 1) = 0
     m(i, 1) = 0.0
@@ -907,10 +898,10 @@
   DO j = minorig + 1, nl
     DO i = 1, ncum
-      IF ((j>=(icb(i)+1)) .AND. (j<=inb(i))) THEN
+      IF ((j>=(icb(i) + 1)) .AND. (j<=inb(i))) THEN
         k = min(j, inb1(i))
-        dbo = abs(tv(i,k+1)-tvp(i,k+1)-tv(i,k-1)+tvp(i,k-1)) + &
-          entp*0.04*(ph(i,k)-ph(i,k+1))
+        dbo = abs(tv(i, k + 1) - tvp(i, k + 1) - tv(i, k - 1) + tvp(i, k - 1)) + &
+                entp * 0.04 * (ph(i, k) - ph(i, k + 1))
         work(i) = work(i) + dbo
-        m(i, j) = cbmf(i)*dbo
+        m(i, j) = cbmf(i) * dbo
       END IF
     END DO
@@ -918,6 +909,6 @@
   DO k = minorig + 1, nl
     DO i = 1, ncum
-      IF ((k>=(icb(i)+1)) .AND. (k<=inb(i))) THEN
-        m(i, k) = m(i, k)/work(i)
+      IF ((k>=(icb(i) + 1)) .AND. (k<=inb(i))) THEN
+        m(i, k) = m(i, k) / work(i)
       END IF
     END DO
@@ -931,43 +922,42 @@
   ! =====================================================================
 
-
   DO i = minorig + 1, nl
     DO j = minorig + 1, nl
       DO ij = 1, ncum
-        IF ((i>=(icb(ij)+1)) .AND. (j>=icb(ij)) .AND. (i<=inb(ij)) .AND. (j<= &
-            inb(ij))) THEN
-          qti = qnk(ij) - ep(ij, i)*clw(ij, i)
-          bf2 = 1. + lv(ij, j)*lv(ij, j)*qs(ij, j)/(rrv*t(ij,j)*t(ij,j)*cpd)
-          anum = h(ij, j) - hp(ij, i) + (cpv-cpd)*t(ij, j)*(qti-q(ij,j))
-          denom = h(ij, i) - hp(ij, i) + (cpd-cpv)*(q(ij,i)-qti)*t(ij, j)
+        IF ((i>=(icb(ij) + 1)) .AND. (j>=icb(ij)) .AND. (i<=inb(ij)) .AND. (j<= &
+                inb(ij))) THEN
+          qti = qnk(ij) - ep(ij, i) * clw(ij, i)
+          bf2 = 1. + lv(ij, j) * lv(ij, j) * qs(ij, j) / (rrv * t(ij, j) * t(ij, j) * cpd)
+          anum = h(ij, j) - hp(ij, i) + (cpv - cpd) * t(ij, j) * (qti - q(ij, j))
+          denom = h(ij, i) - hp(ij, i) + (cpd - cpv) * (q(ij, i) - qti) * t(ij, j)
           dei = denom
           IF (abs(dei)<0.01) dei = 0.01
-          sij(ij, i, j) = anum/dei
+          sij(ij, i, j) = anum / dei
           sij(ij, i, i) = 1.0
-          altem = sij(ij, i, j)*q(ij, i) + (1.-sij(ij,i,j))*qti - qs(ij, j)
-          altem = altem/bf2
-          cwat = clw(ij, j)*(1.-ep(ij,j))
+          altem = sij(ij, i, j) * q(ij, i) + (1. - sij(ij, i, j)) * qti - qs(ij, j)
+          altem = altem / bf2
+          cwat = clw(ij, j) * (1. - ep(ij, j))
           stemp = sij(ij, i, j)
           IF ((stemp<0.0 .OR. stemp>1.0 .OR. altem>cwat) .AND. j>i) THEN
-            anum = anum - lv(ij, j)*(qti-qs(ij,j)-cwat*bf2)
-            denom = denom + lv(ij, j)*(q(ij,i)-qti)
+            anum = anum - lv(ij, j) * (qti - qs(ij, j) - cwat * bf2)
+            denom = denom + lv(ij, j) * (q(ij, i) - qti)
             IF (abs(denom)<0.01) denom = 0.01
-            sij(ij, i, j) = anum/denom
-            altem = sij(ij, i, j)*q(ij, i) + (1.-sij(ij,i,j))*qti - qs(ij, j)
-            altem = altem - (bf2-1.)*cwat
+            sij(ij, i, j) = anum / denom
+            altem = sij(ij, i, j) * q(ij, i) + (1. - sij(ij, i, j)) * qti - qs(ij, j)
+            altem = altem - (bf2 - 1.) * cwat
           END IF
-          IF (sij(ij,i,j)>0.0 .AND. sij(ij,i,j)<0.9) THEN
-            qent(ij, i, j) = sij(ij, i, j)*q(ij, i) + (1.-sij(ij,i,j))*qti
-            uent(ij, i, j) = sij(ij, i, j)*u(ij, i) + &
-              (1.-sij(ij,i,j))*u(ij, nk(ij))
-            vent(ij, i, j) = sij(ij, i, j)*v(ij, i) + &
-              (1.-sij(ij,i,j))*v(ij, nk(ij))
+          IF (sij(ij, i, j)>0.0 .AND. sij(ij, i, j)<0.9) THEN
+            qent(ij, i, j) = sij(ij, i, j) * q(ij, i) + (1. - sij(ij, i, j)) * qti
+            uent(ij, i, j) = sij(ij, i, j) * u(ij, i) + &
+                    (1. - sij(ij, i, j)) * u(ij, nk(ij))
+            vent(ij, i, j) = sij(ij, i, j) * v(ij, i) + &
+                    (1. - sij(ij, i, j)) * v(ij, nk(ij))
             elij(ij, i, j) = altem
-            elij(ij, i, j) = max(0.0, elij(ij,i,j))
-            ment(ij, i, j) = m(ij, i)/(1.-sij(ij,i,j))
+            elij(ij, i, j) = max(0.0, elij(ij, i, j))
+            ment(ij, i, j) = m(ij, i) / (1. - sij(ij, i, j))
             nent(ij, i) = nent(ij, i) + 1
           END IF
-          sij(ij, i, j) = max(0.0, sij(ij,i,j))
-          sij(ij, i, j) = min(1.0, sij(ij,i,j))
+          sij(ij, i, j) = max(0.0, sij(ij, i, j))
+          sij(ij, i, j) = min(1.0, sij(ij, i, j))
         END IF
       END DO
@@ -980,7 +970,7 @@
 
     DO ij = 1, ncum
-      IF ((i>=(icb(ij)+1)) .AND. (i<=inb(ij)) .AND. (nent(ij,i)==0)) THEN
+      IF ((i>=(icb(ij) + 1)) .AND. (i<=inb(ij)) .AND. (nent(ij, i)==0)) THEN
         ment(ij, i, i) = m(ij, i)
-        qent(ij, i, i) = q(ij, nk(ij)) - ep(ij, i)*clw(ij, i)
+        qent(ij, i, i) = q(ij, nk(ij)) - ep(ij, i) * clw(ij, i)
         uent(ij, i, i) = u(ij, nk(ij))
         vent(ij, i, i) = v(ij, nk(ij))
@@ -1000,5 +990,5 @@
   ! =====================================================================
 
-  CALL zilch(bsum, ncum*nlp)
+  CALL zilch(bsum, ncum * nlp)
   DO ij = 1, ncum
     lwork(ij) = .FALSE.
@@ -1008,17 +998,17 @@
     num1 = 0
     DO ij = 1, ncum
-      IF ((i>=icb(ij)+1) .AND. (i<=inb(ij))) num1 = num1 + 1
+      IF ((i>=icb(ij) + 1) .AND. (i<=inb(ij))) num1 = num1 + 1
     END DO
     IF (num1<=0) GO TO 789
 
     DO ij = 1, ncum
-      IF ((i>=icb(ij)+1) .AND. (i<=inb(ij))) THEN
-        lwork(ij) = (nent(ij,i)/=0)
-        qp1 = q(ij, nk(ij)) - ep(ij, i)*clw(ij, i)
-        anum = h(ij, i) - hp(ij, i) - lv(ij, i)*(qp1-qs(ij,i))
-        denom = h(ij, i) - hp(ij, i) + lv(ij, i)*(q(ij,i)-qp1)
+      IF ((i>=icb(ij) + 1) .AND. (i<=inb(ij))) THEN
+        lwork(ij) = (nent(ij, i)/=0)
+        qp1 = q(ij, nk(ij)) - ep(ij, i) * clw(ij, i)
+        anum = h(ij, i) - hp(ij, i) - lv(ij, i) * (qp1 - qs(ij, i))
+        denom = h(ij, i) - hp(ij, i) + lv(ij, i) * (q(ij, i) - qp1)
         IF (abs(denom)<0.01) denom = 0.01
-        scrit(ij) = anum/denom
-        alt = qp1 - qs(ij, i) + scrit(ij)*(q(ij,i)-qp1)
+        scrit(ij) = anum / denom
+        alt = qp1 - qs(ij, i) + scrit(ij) * (q(ij, i) - qp1)
         IF (scrit(ij)<0.0 .OR. alt<0.0) scrit(ij) = 1.0
         asij(ij) = 0.0
@@ -1030,42 +1020,42 @@
       num2 = 0
       DO ij = 1, ncum
-        IF ((i>=icb(ij)+1) .AND. (i<=inb(ij)) .AND. (j>=icb( &
-          ij)) .AND. (j<=inb(ij)) .AND. lwork(ij)) num2 = num2 + 1
+        IF ((i>=icb(ij) + 1) .AND. (i<=inb(ij)) .AND. (j>=icb(&
+                ij)) .AND. (j<=inb(ij)) .AND. lwork(ij)) num2 = num2 + 1
       END DO
       IF (num2<=0) GO TO 783
 
       DO ij = 1, ncum
-        IF ((i>=icb(ij)+1) .AND. (i<=inb(ij)) .AND. (j>=icb( &
-            ij)) .AND. (j<=inb(ij)) .AND. lwork(ij)) THEN
-          IF (sij(ij,i,j)>0.0 .AND. sij(ij,i,j)<0.9) THEN
+        IF ((i>=icb(ij) + 1) .AND. (i<=inb(ij)) .AND. (j>=icb(&
+                ij)) .AND. (j<=inb(ij)) .AND. lwork(ij)) THEN
+          IF (sij(ij, i, j)>0.0 .AND. sij(ij, i, j)<0.9) THEN
             IF (j>i) THEN
-              smid = min(sij(ij,i,j), scrit(ij))
+              smid = min(sij(ij, i, j), scrit(ij))
               sjmax = smid
               sjmin = smid
-              IF (smid<smin(ij) .AND. sij(ij,i,j+1)<smid) THEN
+              IF (smid<smin(ij) .AND. sij(ij, i, j + 1)<smid) THEN
                 smin(ij) = smid
-                sjmax = min(sij(ij,i,j+1), sij(ij,i,j), scrit(ij))
-                sjmin = max(sij(ij,i,j-1), sij(ij,i,j))
+                sjmax = min(sij(ij, i, j + 1), sij(ij, i, j), scrit(ij))
+                sjmin = max(sij(ij, i, j - 1), sij(ij, i, j))
                 sjmin = min(sjmin, scrit(ij))
               END IF
             ELSE
-              sjmax = max(sij(ij,i,j+1), scrit(ij))
-              smid = max(sij(ij,i,j), scrit(ij))
+              sjmax = max(sij(ij, i, j + 1), scrit(ij))
+              smid = max(sij(ij, i, j), scrit(ij))
               sjmin = 0.0
-              IF (j>1) sjmin = sij(ij, i, j-1)
+              IF (j>1) sjmin = sij(ij, i, j - 1)
               sjmin = max(sjmin, scrit(ij))
             END IF
-            delp = abs(sjmax-smid)
-            delm = abs(sjmin-smid)
-            asij(ij) = asij(ij) + (delp+delm)*(ph(ij,j)-ph(ij,j+1))
-            ment(ij, i, j) = ment(ij, i, j)*(delp+delm)*(ph(ij,j)-ph(ij,j+1))
+            delp = abs(sjmax - smid)
+            delm = abs(sjmin - smid)
+            asij(ij) = asij(ij) + (delp + delm) * (ph(ij, j) - ph(ij, j + 1))
+            ment(ij, i, j) = ment(ij, i, j) * (delp + delm) * (ph(ij, j) - ph(ij, j + 1))
           END IF
         END IF
       END DO
-783 END DO
+    783 END DO
     DO ij = 1, ncum
-      IF ((i>=icb(ij)+1) .AND. (i<=inb(ij)) .AND. lwork(ij)) THEN
+      IF ((i>=icb(ij) + 1) .AND. (i<=inb(ij)) .AND. lwork(ij)) THEN
         asij(ij) = max(1.0E-21, asij(ij))
-        asij(ij) = 1.0/asij(ij)
+        asij(ij) = 1.0 / asij(ij)
         bsum(ij, i) = 0.0
       END IF
@@ -1073,7 +1063,7 @@
     DO j = minorig, nl + 1
       DO ij = 1, ncum
-        IF ((i>=icb(ij)+1) .AND. (i<=inb(ij)) .AND. (j>=icb( &
-            ij)) .AND. (j<=inb(ij)) .AND. lwork(ij)) THEN
-          ment(ij, i, j) = ment(ij, i, j)*asij(ij)
+        IF ((i>=icb(ij) + 1) .AND. (i<=inb(ij)) .AND. (j>=icb(&
+                ij)) .AND. (j<=inb(ij)) .AND. lwork(ij)) THEN
+          ment(ij, i, j) = ment(ij, i, j) * asij(ij)
           bsum(ij, i) = bsum(ij, i) + ment(ij, i, j)
         END IF
@@ -1081,9 +1071,9 @@
     END DO
     DO ij = 1, ncum
-      IF ((i>=icb(ij)+1) .AND. (i<=inb(ij)) .AND. (bsum(ij, &
-          i)<1.0E-18) .AND. lwork(ij)) THEN
+      IF ((i>=icb(ij) + 1) .AND. (i<=inb(ij)) .AND. (bsum(ij, &
+              i)<1.0E-18) .AND. lwork(ij)) THEN
         nent(ij, i) = 0
         ment(ij, i, i) = m(ij, i)
-        qent(ij, i, i) = q(ij, nk(ij)) - ep(ij, i)*clw(ij, i)
+        qent(ij, i, i) = q(ij, nk(ij)) - ep(ij, i) * clw(ij, i)
         uent(ij, i, i) = u(ij, nk(ij))
         vent(ij, i, i) = v(ij, nk(ij))
@@ -1092,15 +1082,14 @@
       END IF
     END DO
-789 END DO
-
+  789 END DO
 
 END SUBROUTINE cv_mixing
 
 SUBROUTINE cv_unsat(nloc, ncum, nd, inb, t, q, qs, gz, u, v, p, ph, h, lv, &
-    ep, sigp, clw, m, ment, elij, iflag, mp, qp, up, vp, wt, water, evap)
+        ep, sigp, clw, m, ment, elij, iflag, mp, qp, up, vp, wt, water, evap)
+  USE lmdz_cvthermo
+
   IMPLICIT NONE
 
-
-  include "cvthermo.h"
   include "cvparam.h"
 
@@ -1110,5 +1099,5 @@
   REAL t(nloc, nd), q(nloc, nd), qs(nloc, nd)
   REAL gz(nloc, nd), u(nloc, nd), v(nloc, nd)
-  REAL p(nloc, nd), ph(nloc, nd+1), h(nloc, nd)
+  REAL p(nloc, nd), ph(nloc, nd + 1), h(nloc, nd)
   REAL lv(nloc, nd), ep(nloc, nd), sigp(nloc, nd), clw(nloc, nd)
   REAL m(nloc, nd), ment(nloc, nd, nd), elij(nloc, nd, nd)
@@ -1150,7 +1139,7 @@
   DO k = 2, nl + 1
     DO i = 1, ncum
-      qp(i, k) = q(i, k-1)
-      up(i, k) = u(i, k-1)
-      vp(i, k) = v(i, k-1)
+      qp(i, k) = q(i, k - 1)
+      up(i, k) = u(i, k - 1)
+      vp(i, k) = v(i, k - 1)
     END DO
   END DO
@@ -1164,8 +1153,7 @@
   ! ***                and condensed water flux                    ***
 
-
   DO i = 1, ncum
     jtt(i) = 2
-    IF (ep(i,inb(i))<=0.0001) iflag(i) = 2
+    IF (ep(i, inb(i))<=0.0001) iflag(i) = 2
     IF (iflag(i)==0) THEN
       lwork(i) = .TRUE.
@@ -1177,5 +1165,4 @@
   ! ***                    Begin downdraft loop                    ***
 
-
   CALL zilch(wdtrain, ncum)
   DO i = nl + 1, 1, -1
@@ -1192,5 +1179,5 @@
     DO ij = 1, ncum
       IF ((i<=inb(ij)) .AND. (lwork(ij))) THEN
-        wdtrain(ij) = g*ep(ij, i)*m(ij, i)*clw(ij, i)
+        wdtrain(ij) = g * ep(ij, i) * m(ij, i) * clw(ij, i)
       END IF
     END DO
@@ -1200,7 +1187,7 @@
         DO ij = 1, ncum
           IF ((i<=inb(ij)) .AND. (lwork(ij))) THEN
-            awat = elij(ij, j, i) - (1.-ep(ij,i))*clw(ij, i)
+            awat = elij(ij, j, i) - (1. - ep(ij, i)) * clw(ij, i)
             awat = max(0.0, awat)
-            wdtrain(ij) = wdtrain(ij) + g*awat*ment(ij, j, i)
+            wdtrain(ij) = wdtrain(ij) + g * awat * ment(ij, j, i)
           END IF
         END DO
@@ -1223,19 +1210,19 @@
         ! rain   ***
 
-        IF (t(ij,i)>273.0) THEN
+        IF (t(ij, i)>273.0) THEN
           coeff = coeffr
           wt(ij, i) = omtrain
         END IF
-        qsm = 0.5*(q(ij,i)+qp(ij,i+1))
-        afac = coeff*ph(ij, i)*(qs(ij,i)-qsm)/(1.0E4+2.0E3*ph(ij,i)*qs(ij,i))
+        qsm = 0.5 * (q(ij, i) + qp(ij, i + 1))
+        afac = coeff * ph(ij, i) * (qs(ij, i) - qsm) / (1.0E4 + 2.0E3 * ph(ij, i) * qs(ij, i))
         afac = max(afac, 0.0)
         sigt = sigp(ij, i)
         sigt = max(0.0, sigt)
         sigt = min(1.0, sigt)
-        b6 = 100.*(ph(ij,i)-ph(ij,i+1))*sigt*afac/wt(ij, i)
-        c6 = (water(ij,i+1)*wt(ij,i+1)+wdtrain(ij)/sigd)/wt(ij, i)
-        revap = 0.5*(-b6+sqrt(b6*b6+4.*c6))
-        evap(ij, i) = sigt*afac*revap
-        water(ij, i) = revap*revap
+        b6 = 100. * (ph(ij, i) - ph(ij, i + 1)) * sigt * afac / wt(ij, i)
+        c6 = (water(ij, i + 1) * wt(ij, i + 1) + wdtrain(ij) / sigd) / wt(ij, i)
+        revap = 0.5 * (-b6 + sqrt(b6 * b6 + 4. * c6))
+        evap(ij, i) = sigt * afac * revap
+        water(ij, i) = revap * revap
 
         ! ***  Calculate precipitating downdraft mass flux under     ***
